<?php
	
	/*
	Plugin Name: OurEgo Languages
	Plugin URI: http://ourego.com/wordpress/plugins/ourego-languages/
	Description: Language handling plugin.
	Version: 0.9.6
	Author: Hans Larsson
	Author URI: http://hans.ourego.com/
	
	This is the implementation of the language admin functions.
	The admin features enhances the admin menu, list/edit post, list/edit page, list categories,
	and edit user in the WordPress admin GUI. It also adds a language admin page and menu item.
 
	2013-08-23
	
	TODO: Fix language switching based on edit post/page.
	
	*/

	// Automatic updates parameters

		$ourego_languages_version = '0.9.6';



	// The code

		add_action('init','language_setter',1);

		global $locale;
		global $admin_language;
		global $language_fallback;$language_fallback = 'en';
		global $languages_dir;$languages_dir = dirname(__FILE__).'/cache';
		global $languages_file_available;$languages_file_available = $languages_dir.'/languages_available.txt';
		global $languages_file_all;$languages_file_all = $languages_dir.'/languages_all.txt';

		define('WPLANGS',availableLanguages($language_fallback));
		if(defined('WPLANG')){
			if(WPLANG == ''){
				$locale = extractLangFromCall($language_fallback);
				update_site_option('WPLANG',$locale);
			}
		}else{
			define('WPLANG',extractLangFromCall($language_fallback));
		}	

		function extractLangFromCall($default = ''){
			global $wpdb;
			$url = $_SERVER['REQUEST_URI'];$host = $_SERVER["HTTP_HOST"];$lang = $_GET['lang'];$query = $_SERVER['QUERY_STRING'];
			if($lang == ''){if(preg_match('/.*?\/([a-z]{2})\/.*?/',$url,$match)){$lang = $match[1];}else if(preg_match('/.*?\/([a-z]{2})\/.*?/',$host,$match)){$lang = $match[1];}}
			if($lang == ''){if(preg_match('/.*?page_id=([1-9]).*?/',$query,$match)){$lang = $match[1];if($lang != ''){$lang = $wpdb->get_var($wpdb->prepare("SELECT post_name FROM $wpdb->posts WHERE ID = %s",$lang));}else{$lang = '';}}}
			if(!in_array($lang,explode(',',WPLANGS))){$lang = '';}
			if($lang == ''){if(isset($_COOKIE["language-last"])){$lang = $_COOKIE["language-last"];}}
			if($lang == ''){$lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2);}
			if(!in_array($lang,explode(',',WPLANGS))){$lang = '';}
			if($lang == ''){$lang = $default;}
			if($_COOKIE["language-last"] != $lang){setcookie("language-last",$lang,time()+60*60*24*30,'/');}
			return getLocale($lang);
		}

		function availableLanguages($default){
			global $languages_file_available,$languages_file_all;
			$languages_file = '';
			$available = '';
			if(isset($_COOKIE["language-login"]) && $_COOKIE["language-login"] == 'true'){
				$languages_file = $languages_file_all;
			}else{
				$languages_file = $languages_file_available;
			}
			if(file_exists($languages_file)){
				$available = file_get_contents($languages_file);
			}else{
				$available = $default;
			}
			return $available;
		}

		function language_options(){
			$options = array (
				array(
					'name' => __('Languages'),
			        'type' => 'heading',
					'desc' => '',
				),
				array(
					'name' => __('Select which languages should be available on the site.'),
					'desc' => __('All available languages'),
					'id' => 'language_languages',
					'std' => '',
					'type' => 'set-languages',
				),
				array(
					'name' => __('Select which languages should be in the language selector on the site.'),
					'desc' => '',
					'id' => 'language_available',
					'std' => '',
					'type' => 'set-available',
				)
			);
			update_option('language_template',$options);
		}


	//GENERAL HELPERS

		//Get language

			function get_language_slug(){
				global $locale;
				if(get_bloginfo('language') == ''){
					$languageSlug = substr($locale,0,2);
				}else{
					$languageSlug = substr(get_bloginfo('language'),0,2);
				}
				return $languageSlug;
			}


		//Get post

			function get_language_post_by_slug($postName){
				global $wpdb;
				if($postName != ''){
					$postId = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_name = %s",$postName));
					if($postId){
						return get_post($postId,OBJECT);
					}else{
						return null;
					}
				}else{
					return null;
				}
			}

			
		//Get page

			function get_language_page($slug){
				$page = get_page_by_path($slug);
				if($page){
					return $page;
				}else{
					$pages = get_pages();
					foreach($pages as $page){
						if($page->post_name == $slug){
							return $page;
							break;
						}		
					}
					return '';
				}
			}

			function get_language_page_id($slug){
				$page = get_language_page($slug);
				if($page){
					return $page->ID;
				}else{
					return '';
				}
			}



	//LANGUAGE ACTION AND FILTER FUNCTIONS

		// Language setter

			function language_setter(){
				global $user_ID,$query_string;
				if($user_ID){
					if(current_user_can('level_10')){
						setcookie('language-login','true',time()+60*60*24*30,'/');
					}else{
						setcookie('language-login','false',time()+60*60*24*30,'/');
					}
				}else{
					setcookie('language-login','false',time()+60*60*24*30,'/');
				}
				if(is_admin()){
					language_admin_setter();
				}else{
					$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
					$host = $_SERVER["HTTP_HOST"];
					$uri = $_SERVER['REQUEST_URI'];if($query_string != ''){$uri .= '?'.$query_string;}
					if($_SERVER["REQUEST_URI"]=='/' || get_permalink(get_language_page(get_language_slug())->ID) == $protocol.$host.$uri){
						$pagekids = get_pages("child_of=".get_language_page(get_language_slug())->ID."&sort_column=menu_order");
						$firstchild = $pagekids[0];
						wp_redirect(get_permalink($firstchild->ID));
						exit;
					}else{
						add_action('init','set_language_sidebars');
						add_filter('pre_get_posts','set_language_posts');
						add_filter('list_terms_exclusions','set_language_categories');
						add_filter('wp_nav_menu_objects','set_language_menus');
						add_filter('wp_get_nav_menu_items','set_language_menus');
						add_filter('sidebars_widgets','set_language_filter_widgets');
						add_filter('get_the_categories','set_language_categories');
						//add_filter('bloginfo','set_language_bloginfo',1,2);
					}
				}
			}

			function language_admin_setter(){
				global $user_ID,$admin_language;
				$language_get = $_GET['language'];
				$language_array = getLanguages();
				if($language_array){
					if($language_get && in_array($language_get,$language_array)){
						$admin_language = $language_get;
						update_user_meta($user_ID,'language',$language_get);
					}else{
						if(!$admin_language){
							if(in_array(get_the_author_meta('language',$user_ID),$language_array)){
								$admin_language = get_the_author_meta('language',$user_ID);
							}
						}else{
							if(!in_array($admin_language,$language_array)){
								$admin_language = '';
							}
						}
						if(!$admin_language){
							$admin_language = get_language_slug();
							update_user_meta($user_ID,'language',get_language_slug());
						}
					}
					add_action('admin_head','language_admin_styles');
					add_action('admin_menu','language_admin_menu',8);
					add_action('show_user_profile','user_languages');
					add_action('edit_user_profile','user_languages');
					add_action('personal_options_update','user_languages_save');
					add_action('edit_user_profile_update','user_languages_save');
					add_filter('pre_get_posts','language_exclude_posts');
					add_filter('the_title','language_page_title');
					add_filter('list_terms_exclusions','language_exclude_categories');
					add_action('wp_insert_post','language_new_post');
					add_filter('wp_insert_post_data','language_new_post_data','99',2);
					add_action('init','language_register_sidebars');	
					add_action('admin_print_footer_scripts','language_scripts',99);
					add_action('widgets_admin_page','language_sidebars_label');
				}
				language_options();
				add_action('admin_menu','language_add_admin');
			}


	// Language admin styles (display what language is used)

		function language_admin_styles(){
			global $pagenow,$user_ID,$admin_language;
			echo '<style type="text/css">td.admin_language {background-color:#777777 !important;border:1px solid #000000 !important;color:#ffffff !important;}';
			echo '<style type="text/css">a.wp-first-item.menu-top {background-color:#777777 !important;border:1px solid #000000 !important;color:#ffffff !important;} li.wp-first-item li.wp-first-item {display:none;}</style>';
			echo '<style type="text/css">#post-'.get_language_page($admin_language)->ID.' {background-color:#777777 !important;border:1px solid #000000 !important;color:#ffffff !important;} #post-'.get_language_page($admin_language)->ID.' a{color:#ffffff !important;}</style>';
			if($pagenow == 'edit-tags.php'){
				echo '<style type="text/css">';
				echo '	#tag-'.get_category_by_slug($admin_language)->cat_ID.' {background-color:#777777 !important;border:1px solid #000000 !important;color:#ffffff !important;} #tag-'.get_category_by_slug($admin_language)->cat_ID.' a{color:#ffffff !important;}';
				foreach(get_categories(array('hide_empty'=>false)) as $category){
					$hide = false;
					if($category->slug != $admin_language && !cat_is_ancestor_of(get_category_by_slug($admin_language),$category)){
						if(in_array($category->slug,getLanguages())){
							$hide = true;
						}
					}
					if(!$hide){
						foreach(getLanguages() as $language){
							if($language != $admin_language){
								if(cat_is_ancestor_of(get_category_by_slug($language),$category)){
									$hide = true;
									break;
								}
							}
						}
					}
					if($hide){
						echo ' #tag-'.$category->cat_ID.' {display:none;}';
					}
				}
				echo '</style>';
			}
			echo '<style type="text/css">.subsubsub span.count {display:none !important;}</style>';
			echo '<style type="text/css">#widgets-right {display:none;}</style>';
			if($pagenow == 'nav-menus.php'){
				echo '<style type="text/css">';
				echo ' #add-post {display:none;}';
				echo ' #add-custom-links {display:none;}';
				echo ' #add-post_tag {display:none;}';
				foreach(wp_get_nav_menus() as $menu){
					foreach(wp_get_nav_menu_items($menu->term_id) as $item){
						if($item->object == 'post'){
						}elseif($item->object == 'page'){
							$hide = true;
							$ancestors = get_ancestors($item->object_id,'page');
							$languagePage = get_language_page_id($admin_language);
							if(in_array($languagePage,$ancestors)){
								$hide = false;
							}
							if($hide){
								echo ' #menu-item-'.$item->ID.' {display:none;}';
							}
						}elseif($item->object == 'category'){
							$hide = false;
							$category = get_category($item->object_id);
							if($category->slug != $admin_language && !cat_is_ancestor_of(get_category_by_slug($admin_language),$category)){
								if(in_array($category->slug,getLanguages())){
									$hide = true;
								}
							}
							if(!$hide){
								foreach(getLanguages() as $language){
									if($language != $admin_language){
										if(cat_is_ancestor_of(get_category_by_slug($language),$category)){
											$hide = true;
											break;
										}
									}
								}
							}
							if($hide){
								echo ' #menu-item-'.$item->ID.' {display:none;}';
							}
						}elseif($item->object == 'post_tag'){
							//OBS! TODO
						}
					}
				}
				echo '</style>';
			}
			if($pagenow == 'link-manager.php'){
				echo '<style type="text/css">';
				$terms = get_terms('link_category');
				if($terms){
					foreach($terms as $term){
						if($term->count > 0 && $admin_language != substr($term->slug,strpos($term->slug,'-')+1) && in_array(substr($term->slug,strpos($term->slug,'-')+1),getLanguages())){
							foreach(get_bookmarks(array('category' => $term->term_id)) as $bookmark){
								echo ' #link-'.$bookmark->link_id.' {display:none;}';
							}
						}
					}
				}
				echo '</style>';
			}
			wp_get_nav_menu_items( $menu, $args );
		}


	// Language switcher for the admin menu.

		function language_admin_menu(){
			global $pagenow,$user_ID,$admin_language;
			$languages = getLanguages();
			$user_languages = get_the_author_meta('user_languages',$user_ID);if(!$user_languages){$user_languages = array();}
			$selectedLink = add_query_arg('language',$admin_language);
			$selectedLink = (strpos($selectedLink,"wp-admin/") === false) ? preg_replace('#[^?&]*/#i','',$selectedLink):preg_replace('#[^?&]*wp-admin/#i','',$selectedLink);
			if(strpos($selectedLink,"?") === 0 || strpos($selectedLink,"index.php?") === 0){
				$selectedLink = 'edit.php?language='.$admin_language;
			}
			add_menu_page(getLanguageName($admin_language),getLanguageName($admin_language),'read',$selectedLink,NULL,plugins_url('flags/'.strtolower(getLocale($admin_language,true)).'.png',__FILE__),1);
			$first = true;
			foreach($languages as $lang){
				if(get_category_by_slug($lang) && in_array($lang,$user_languages)){
					$link = add_query_arg('language',$lang);
					$link = (strpos($link,"wp-admin/") === false) ? preg_replace('#[^?&]*/#i','',$link):preg_replace('#[^?&]*wp-admin/#i','',$link);
					if(strpos($link,"?") === 0 || strpos($link,"index.php?") === 0){
						$link = 'edit.php?language='.$lang;
					}
					if(strpos($link,"post.php?") === 0){
						$link = 'edit.php?language='.$lang;
					}
					if($lang == $admin_language){
						if($first){
							add_submenu_page($selectedLink,getLanguageName($lang),'<b>'.getLanguageName($lang).'</b>','read',$link,NULL);
						}
						add_submenu_page($selectedLink,getLanguageName($lang),'<b>'.getLanguageName($lang).'</b>','read',$link,NULL);
					}else{
						add_submenu_page($selectedLink,getLanguageName($lang),getLanguageName($lang),'read',$link,NULL);
					}
					$first = false;
				}
			}
		}


	// Language admin menu item and GUI.

		function language_add_admin(){
			$options = get_option('language_template');
			if(isset($_GET['page'])){
				if($_GET['page'] == basename(__FILE__)){
					if('save' == $_REQUEST['action']){
						foreach($options as $value){
							if($value['type'] == "set-languages"){
								language_admin_save_set_languages($value);
							}elseif($value['type'] == "set-available"){
								language_admin_save_set_available($value);
							}else{
								if(isset($_REQUEST[$value['id']])){update_option($value['id'],$_REQUEST[$value['id']]);}else{delete_option($value['id']);}
							}
						}
					    header("Location: options-general.php?page=ourego-languages.php&saved=true");
						die;
					}elseif('reset' == $_REQUEST['action']){
						foreach($options as $value){
							delete_option($value['id']);
							update_option($value['id'],$value['std']);
						}
			  	        header("Location: options-general.php?page=ourego-languages.php&reset=true");
			            die;
			        }
			    }
			}
			add_options_page("Languages","Languages",'manage_options',basename(__FILE__),'language_admin');
		}

		function language_admin(){
			$options = get_option('language_template');
			if($_REQUEST['saved']) echo '<div id="message" class="updated fade"><p><strong>'.__('Theme options saved').'</strong></p></div>';
			if($_REQUEST['reset']) echo '<div id="message" class="updated fade"><p><strong>'.__('Theme options reset').'</strong></p></div>';
			?>
				<div class="wrap">
					<div id="icon-themes" class="icon32"><br></div><h2><?php _e('Theme Options'); ?></h2>
					<form method="post">
						<?php
							foreach($options as $value){
								$setting = get_option($value['id']);
								if($value['type'] == "heading"){
									?>
										<h3><?php echo $value['name']; ?>:</h3>
										<?php if($value['desc'] != ''){ ?><p><?php echo $value['desc']; ?></p><?php } ?>
									<?php
								}else{
									?>
										<table class="form-table">
											<tr> 
												<th><?php echo $value['name']; ?><?php if($value['desc'] != ''){ ?><span class="description">(<?php echo $value['desc']; ?>)</span><?php } ?></th>
												<td>
													<?php
														if($value['type'] == "text"){ 
															?>
																<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if($setting != ""){ echo $setting; } else { echo $value['std']; } ?>" size="40" />
															<?php
														}elseif($value['type'] == "textarea"){
															?>
														       <textarea name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" cols="50" rows="8"/><?php if($setting != ""){ echo stripslashes($setting); }else{echo $value['std']; } ?></textarea>
															<?php
														}elseif($value['type'] == "select"){
															?>
													            <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
													                <?php foreach ($value['options'] as $option) { ?>
														                <option<?php if($setting == $option) { echo ' selected="selected"'; }?>><?php echo $option; ?></option>
							        						        <?php } ?>
							        						    </select>
															<?php
														}elseif($value['type'] == "set-languages"){
															language_admin_set_languages($value,$setting);
														}elseif($value['type'] == "set-available"){
															language_admin_set_available($value,$setting);
														}
													?>
												</td>
											</tr>
										</table>
									<?php
								}
							}
						?>
						<p class="submit">
							<input name="save" type="submit" class="button-primary" value="Save changes" />    
							<input type="hidden" name="action" value="save" />
						</p>
					</form>
					<form method="post">
						<p class="submit">
							<input name="reset" type="submit" value="Reset" />
							<input type="hidden" name="action" value="reset" />
						</p>
					</form>
				</div>
			<?php
		}

		function language_admin_set_languages($value,$setting){
			global $language_fallback;
			$languages = array_keys(getLocale());
			if($languages){
				?>
					<table width="100%">
						<?php
							$cols = 4;
							$number = 0;
							foreach($languages as $lang){
								$number++;
								if($number == 1){ ?><tr><?php }
								?>
									<td width="<?php echo 100/$cols; ?>%">
										<label for="<?php echo $value['id'].'_'.$lang; ?>">
											<input id="<?php echo $value['id'].'_'.$lang; ?>" name="<?php echo $value['id'].'_'.$lang; ?>" type="checkbox" value="<?php echo $lang; ?>"<?php if(strpos($setting,$lang) !== false){?> checked="checked"<?php } ?>/>
											<?php if($language_fallback == $lang){ ?><b><?php } ?>
												<?php echo getLanguageName($lang); ?>
											<?php if($language_fallback == $lang){ ?></b> (<?php echo __('fallback'); ?>)<?php } ?>
										</label>
									</td>
								<?php
								if($number == $cols){$number = 0; ?></tr><?php }
							}
							if($number != 0){while($number < $cols){$number++; ?><td></td><?php } ?></tr><?php }
						?>
					</table>
				<?php
			}
		}

		function language_admin_save_set_languages($value){
			global $languages_dir,$languages_file_all,$language_fallback;
			$languages = '';
			foreach(array_keys(getLocale()) as $lang){
				if($_REQUEST[$value['id'].'_'.$lang] == $lang){
					$languages .= ','.$lang;
				}elseif($language_fallback == $lang){
					$languages .= ','.$lang;
				}else{
					if(get_category_by_slug($lang)){
						wp_delete_category(get_category_by_slug($lang)->cat_ID);
					}
				}
			}
			$languages = substr($languages,1);
			if($languages != ''){
				update_option($value['id'],$languages);
				if(!file_exists($languages_dir)){mkdir($languages_dir);chmod($languages_dir,0777);}
				$fp = fopen($languages_file_all,'w');
				fwrite($fp,$languages);
				fclose($fp);
			}else{
				delete_option($value['id']);
			}
			foreach(explode(',',$languages) as $lang){
				if(!get_category_by_slug($lang)){
					$category = array(
						'cat_name' => getLanguageName($lang),
						'category_description' => __('Language category for: ').getLanguageName($lang).'.',
						'category_nicename' => $lang,
						'category_parent' => ''
					);
					wp_insert_category($category);
				}
				$createLinkCategory = true;
				foreach(get_terms('link_category') as $term){
					if($lang == substr($term->slug,strpos($term->slug,'-')+1)){
						$createLinkCategory = false;
						break;
					}
				}
				$category = get_category_by_slug($lang);
				if(!get_language_page($lang)){
					$post = array(
						'comment_status' => 'closed',
						'ping_status' => 'closed',
						'post_category' => array($category->cat_ID),
						'post_content' => __('This is the language page for: ').getLanguageName($lang).'.',
						'post_name' => $lang,
						'post_status' => 'publish', 
						'post_title' => getLanguageName($lang),
						'post_type' => 'page'
					);
					update_post_meta(wp_insert_post($post),'_wp_page_template','languageredirect.php');
				}
			}
		}

		function language_admin_set_available($value,$setting){
			global $language_fallback;
			$languages = getLanguages();
			if($languages){
				?>
					<table width="100%">
						<?php
							$cols = 4;
							$number = 0;
							foreach($languages as $lang){
								$number++;
								if($number == 1){ ?><tr><?php }
								?>
									<td width="<?php echo 100/$cols; ?>%">
										<label for="<?php echo $value['id'].'_'.$lang; ?>">
											<input id="<?php echo $value['id'].'_'.$lang; ?>" name="<?php echo $value['id'].'_'.$lang; ?>" type="checkbox" value="<?php echo $lang; ?>"<?php if(strpos($setting,$lang) !== false){?> checked="checked"<?php } ?>/>
											<?php if($language_fallback == $lang){ ?><b><?php } ?>
												<?php echo getLanguageName($lang); ?>
											<?php if($language_fallback == $lang){ ?></b> (<?php echo __('fallback'); ?>)<?php } ?>
										</label>
									</td>
								<?php
								if($number == $cols){$number = 0; ?></tr><?php }
							}
							if($number != 0){while($number < $cols){$number++; ?><td></td><?php } ?></tr><?php }
						?>
					</table>
				<?php
			}else{
				_e('No language has been set to available in the list abowe.');
			}
		}

		function language_admin_save_set_available($value){
			global $languages_dir,$languages_file_available,$language_fallback;
			$languages = '';
			foreach(getLanguages() as $lang){
				if($_REQUEST[$value['id'].'_'.$lang] == $lang){
					$languages .= ','.$lang;
				}elseif($language_fallback == $lang){
					$languages .= ','.$lang;
				}
			}
			$languages = substr($languages,1);
			if($languages != ''){
				update_option($value['id'],$languages);
				if(!file_exists($languages_dir)){mkdir($languages_dir);chmod($languages_dir,0777);}
				$fp = fopen($languages_file_available,'w');
				fwrite($fp,$languages);
				fclose($fp);
			}else{
				delete_option($value['id']);
			}
		}
	

	// Language user settings GUI addition

		function user_languages($user){
			if(is_admin()){
				$user_languages = get_the_author_meta('user_languages',$user->ID);if(!$user_languages){$user_languages = array();}
				$languages = getLanguages();
				?>
					<h3><?php _e('Available languages'); ?>:</h3>
					<table class="form-table">
						<tr>
							<th><?php _e('The selected languages will be available to the user in the administration.'); ?></th>
							<td>
								<?php
									foreach($languages as $lang){
										if(get_category_by_slug($lang)){
											?>
												<p>
													<label for="user_languages_<?php echo $lang; ?>">
														<input id="user_languages_<?php echo $lang; ?>" name="user_languages[<?php echo $lang; ?>]" type="checkbox" value="<?php echo $lang; ?>"<?php if(in_array($lang,$user_languages)) echo ' checked="checked"'; ?> />
														<?php echo getLanguageName($lang); ?>
													</label>
												</p>
											<?php
										}
									}
								?>
							</td>
						</tr>
					</table>
				<?php
			}
		}

		function user_languages_save($user_id){
			if(is_admin()){
				if(!current_user_can('edit_user',$user_id)){return false;}
				update_user_meta($user_id,'user_languages',$_POST['user_languages']);
			}
		}


	// Filter that excludes posts and pages by language (using the category).

		function language_exclude_posts($query){
			global $user_ID,$admin_language;
			if(is_admin()){
				$languages = getLanguages();
				$excludeCats = '';
				$excludeIds = '';
				foreach($languages as $lang){
					if($lang != $admin_language){
						if(get_category_by_slug($lang)){
							$excludeCats .= ',-'.get_category_by_slug($lang)->cat_ID;
						}
						if(get_language_page($lang)){
							$excludeIds .= ','.get_language_page($lang)->ID;
							$allPages = get_pages(array('child_of' => get_language_page($lang)->ID,'hierarchical' => false));
							foreach($allPages as $aPage){
								$excludeIds .= ','.$aPage->ID;
							}
						}
					}
				}
				$excludeCats = substr($excludeCats,1);
				if(get_language_page('landing')){$excludeIds .= ','.get_language_page('landing')->ID;}
				$excludeIds = explode(',',substr($excludeIds,1));
				if($_GET['post_type'] != 'page'){
					$query->set('cat',$excludeCats);
				}
				$query->set('post__not_in',$excludeIds);
			}
			return $query;	
		}


	// Language page title changer

		function language_page_title($title){
			global $user_ID,$admin_language;
			if($title == getLanguageName($admin_language)){
				$title = $title.' ('.__('Language page','ourego').')';
			}
			return $title;
		}


	// Filter that excludes categories by language.

		function language_exclude_categories(){
			global $pagenow,$wpdb,$admin_language;
			$excluded = '';
			if(is_admin()){
				clean_term_cache('','category');
				$languages = getLanguages();
				$excludeCats = '';
				foreach($languages as $lang){
					if($lang != $admin_language){
						$excludeCats .= ','.get_category_by_slug($lang)->cat_ID;
						$excludeCats .= language_exclude_caregory_children(get_category_by_slug($lang)->cat_ID);
					}
				}
				$excludeCats = substr($excludeCats,1);
				$excluded = " AND ( t.term_id NOT IN ( ".$excludeCats." ) OR tt.taxonomy NOT IN ( 'category' ) )";
			}
			return $excluded;
		}
			function language_exclude_caregory_children($category){
				global $wpdb;
				$excludeCats = '';
				$childCategories = $wpdb->get_col("SELECT term_id FROM $wpdb->term_taxonomy WHERE parent=".$category);
				if($childCategories){
					foreach($childCategories as $childCategory){
						$excludeCats .= ','.$childCategory;
						$excludeCats .= language_exclude_caregory_children($childCategory);
					}
				}
				return $excludeCats;
			}


	// New post, set language if not specified.

		function language_new_post($postId){
			global $pagenow,$admin_language;
			if(get_post($postId)->post_type == 'post' && $pagenow == 'post-new.php'){
				wp_set_post_categories($postId,array(get_category_by_slug($admin_language)->cat_ID));
			}
		}

		function language_new_post_data($data,$raw){
			global $pagenow,$admin_language;
			if($data['post_type'] == 'page' && $pagenow == 'post-new.php'){
				$parent = get_language_post_by_slug($admin_language);
				$data['post_parent'] = $parent->ID;
			}
			return $data;
		}


	// Sidebar per language

		function language_register_sidebars(){
			global $wp_registered_sidebars;
			if(function_exists('register_sidebar')){
				$sidebars;
				foreach($wp_registered_sidebars as $sidebar => $registered_sidebar){
					$sidebars[] = array('id' => $sidebar,'name' => esc_html($registered_sidebar['name']),'description' => esc_html($registered_sidebar['description']));
				}
				$languages = getLanguages();
				foreach($languages as $lang){
					if($sidebars){
						foreach($sidebars as $sidebar){
							register_sidebar(array('id' => $sidebar['id'].'-'.$lang,'name' => $sidebar['name'],'description' => $sidebar['description']));
						}
					}
				}
			}
		}

		function language_sidebars_label(){
			global $admin_language;
			?>
				<div class="widget-liquid-right"><p style="padding:0 0 0 8px;margin:0;"><?php echo getLanguageName($admin_language); ?> <?php _e( 'Widgets' ); ?></p></div>
			<?php
		}


	// Admin language scripts

		function language_scripts(){
			global $pagenow,$admin_language,$wp_registered_sidebars;
			?>
				<script type="text/javascript">
					jQuery(document).ready(function(){
						<?php
							if('widgets.php' == $pagenow || 'post.php' == $pagenow){
								foreach($wp_registered_sidebars as $sidebar => $registered_sidebar){
									if($sidebar != 'wp_inactive_widgets' && substr(strrchr($sidebar,'-'),1) != $admin_language){
										?>
											jQuery('#<?php echo $sidebar; ?>').parent().hide();
										<?php
									}
								}
								?>
									jQuery('#widgets-right').show();
								<?php
							}
						?>
						var publiclink = jQuery('#site-heading > a').attr('href');
						jQuery('#site-heading > a').attr('href',publiclink+'<?php echo $admin_language; ?>/');
					});
				</script>
			<?php
		}


// LANGUAGE FRONTEND CONTENT FUNCTIONS

	// Frontend language posts and pages filtering

		function set_language_posts($query){
			global $user_ID;
			$languages = getLanguages();
			if($languages){
				$excludeCats = '';
				$excludeIds = '';
				foreach($languages as $lang){
					if($lang != get_language_slug()){
						if(get_category_by_slug($lang)){
							$excludeCats .= ',-'.get_category_by_slug($lang)->cat_ID;
						}
						if(get_language_page($lang)){
							$excludeIds .= ','.get_language_page($lang)->ID;
							$allPages = get_pages(array('child_of' => get_language_page($lang)->ID,'hierarchical' => false));
							foreach($allPages as $aPage){
								$excludeIds .= ','.$aPage->ID;
							}
						}
					}
				}
				$excludeCats = substr($excludeCats,1);
				if(get_language_page('landing')){$excludeIds .= ','.get_language_page('landing')->ID;}
				$excludeIds = explode(',',substr($excludeIds,1));
				$query->set('cat',$excludeCats);
				$query->set('post__not_in',$excludeIds);
			}
			return $query;	
		}


	// Frontend categories exclusion.

		function set_language_categories($categories=false){
			global $wpdb,$user_ID;
			$languages = getLanguages();
			if($categories){
				$i = 0;
				foreach($categories as $category){
					if($category->slug == get_language_slug()){
						unset($categories[$i]);
						break;
					}
					$i++;
				}
				return $categories;
			}else{
				$excluded = '';
				if($languages){
					clean_term_cache('','category');
					$excludeCats = '';
					foreach($languages as $lang){
						if($lang != get_language_slug()){
							$excludeCats .= ','.get_category_by_slug($lang)->cat_ID;
							$excludeCats .= set_language_caregory_children(get_category_by_slug($lang)->cat_ID);
						}else{
							$excludeCats .= ','.get_category_by_slug($lang)->cat_ID;
						}
					}
					$excludeCats = substr($excludeCats,1);
					$excluded = " AND ( t.term_id NOT IN ( ".$excludeCats." ) OR tt.taxonomy NOT IN ( 'category' ) )";
				}
				return $excluded;
			}
		}
			function set_language_caregory_children($category){
				global $wpdb;
				$excludeCats = '';
				$childCategories = $wpdb->get_col("SELECT term_id FROM $wpdb->term_taxonomy WHERE parent=".$category);
				if($childCategories){
					foreach($childCategories as $childCategory){
						$excludeCats .= ','.$childCategory;
						$excludeCats .= set_language_caregory_children($childCategory);
					}
				}
				return $excludeCats;
			}

	// Frontend wp_menu exclusion.

		function set_language_menus($objects){
			global $user_ID;
			$languages = getLanguages();
			$filteredObjects;
			if($languages){
				$excludeCats = '';
				foreach($languages as $lang){
					if($lang != get_language_slug()){
						$excludeCats .= ','.get_category_by_slug($lang)->cat_ID;
						$excludeCats .= set_language_caregory_children(get_category_by_slug($lang)->cat_ID);
					}
				}
				$excludeCats = substr($excludeCats,1);
				foreach($objects as $object){
					if($object->object == 'category' && in_array($object->object_id,split(',',$excludeCats))){
					}elseif($object->object == 'page'){
						$ancestors = get_ancestors($object->object_id,'page');
						$languagePage = get_language_page_id(get_language_slug());
						if(in_array($languagePage,$ancestors)){
							$filteredObjects[] = $object;
						}
					}else{
						$filteredObjects[] = $object;
					}
				}
			}else{
				$filteredObjects = $objects;
			}
			return $filteredObjects;
		}


	// Frontend widgets filtering

		function set_language_sidebars(){
			global $wp_registered_widgets,$wp_registered_sidebars,$_wp_sidebars_widgets;
			if(function_exists('register_sidebar')){
				$sidebars = '';
				foreach($_wp_sidebars_widgets as $sidebar => $registered_sidebar){
					if($sidebar != 'wp_inactive_widgets' && substr(strrchr($sidebar,'-'),1) == get_language_slug()){
						$sidebars[substr($sidebar,0,strlen($sidebar)-3)] = $registered_sidebar;
					}
				}
				$_wp_sidebars_widgets = $sidebars;
			}
		}

		function set_language_filter_widgets($sidebars_widgets) {
			global $_wp_sidebars_widgets;
			$sidebars = '';
			$sidebars_widgets_new;
			foreach($sidebars_widgets as $sidebar => $registered_sidebar){
				if($sidebar != 'wp_inactive_widgets'){
					if(substr(strrchr($sidebar,'-'),1) == get_language_slug()){
						$sidebars_widgets_new[substr($sidebar,0,strlen($sidebar)-3)] = $registered_sidebar;
					}else{
						$sidebars_widgets_new[$sidebar] = $registered_sidebar;
					}
				}
			}
			return $sidebars_widgets_new;
		}


	// Frontend bloginfo filtering

		function set_language_bloginfo($result='',$show=''){
			switch($show){
				case 'url':
					$result = $result.'/'.get_language_slug().'/';
					break;
				default: 
			}
			return $result;
		}


	// Create languages list
	
		function createLanguageSelector($type = 'ul'){
			echo getLanguageSelector($type);
		}
		function getLanguageSelector($type = 'ul'){
			global $user_ID;
			$return = '';
			$url = $_SERVER['REQUEST_URI'];
			$languages = getAvailableLanguages();if($user_ID){if(current_user_can('level_10')){$languages = getLanguages();}}
			if($languages){
				$category = language_get_category();
				$categoryParent = $category;while($categoryParent->category_parent){$categoryParent=get_category($categoryParent->category_parent);}
				if($type == 'ul'){
					$return .= '<ul class="languages '.get_language_slug().'" id="languages">';
					foreach($languages as $lang){
						if($lang == get_language_slug()){
							$return .= '<li class="language active" id="language-'.$lang.'">';
						}else{
							$return .= '<li class="language" id="language-'.$lang.'">';
						}
						$pagekids = get_pages("child_of=".get_language_page($lang)->ID."&sort_column=menu_order");
						if($pagekids){ $firstchild = $pagekids[0]; }
						$return .= '<a href="'.get_permalink($firstchild).'">';
						$return .= '<img src="'.plugins_url('flags/'.strtolower(getLocale($lang,true)).'.png',__FILE__).'"/>';
						$return .= getLanguageLocalName($lang);
						$return .= '</a>';
						$return .= '</li>';
					}
					$return .= '</ul>';
				}elseif($type == 'select'){
					$return .= '<select class="languages '.get_language_slug().'" name="languages" id="languages" onchange="document.location=this.value;">';
					foreach($languages as $lang){
						$pagekids = get_pages("child_of=".get_language_page($lang)->ID."&sort_column=menu_order");
						if($pagekids){ $firstchild = $pagekids[0]; }
						if($lang == get_language_slug()){
							$return .= '<option id="language-'.$lang.'" value="'.get_permalink($firstchild).'" selected="selected">';
						}else{
							$return .= '<option id="language-'.$lang.'" value="'.get_permalink($firstchild).'">';
						}
						$return .= getLanguageLocalName($lang);
						$return .= '</option>';
					}
					$return .= '</select>';
				}
			}
			return $return;
		}
			function language_get_category($pageId=''){
				global $post;
				global $wp_query;
				if($pageId == ''){$page = $post;}else{$page = get_page($pageId);}
				$categoryId = get_category_by_slug($page->post_name)->cat_ID;
				if($categoryId != ''){
					return get_category($categoryId);
				}else{
					if($page){
						if($page->post_type == 'post'){	

							//OBS! TODO

						}else{
							foreach($page->ancestors as $ancestorId){
								$categoryId = get_category_by_slug(get_post($ancestorId)->post_name)->cat_ID;
								if(get_category($categoryId)->slug != get_language_slug()){
									if($categoryId != ''){
										return get_category($categoryId);
										break;
									}
								}
							}
						}
					}
					return false;
				}
			}


// LANGUAGE WIDGET

		class OurEgoLanguageWidget extends WP_Widget{
			function OurEgoLanguageWidget(){
				$widget_ops = array('classname' => 'OurEgoLanguageWidget','description' => 'Displays a language selector');
				$this->WP_Widget('OurEgoLanguageWidget','Language selector', $widget_ops);
			}
			function form($instance){
				$instance = wp_parse_args((array)$instance,array('title' => '','type' => 'ul'));
				$title = $instance['title'];
				$type = $instance['type'];
				?><p><label for="<?php echo $this->get_field_id('title'); ?>">Title: <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></label></p><?php
				?><p><label for="<?php echo $this->get_field_id('type'); ?>">Type: <input class="widefat" id="<?php echo $this->get_field_id('type'); ?>" name="<?php echo $this->get_field_name('type'); ?>" type="text" value="<?php echo attribute_escape($type); ?>" /></label></p><?php
			}
			function update($new_instance,$old_instance){
				$instance = $old_instance;
				$instance['title'] = $new_instance['title'];
				$instance['type'] = $new_instance['type'];
				return $instance;
			}
			function widget($args,$instance){
				extract($args,EXTR_SKIP);
				echo $before_widget;
				$title = empty($instance['title']) ? '' : apply_filters('widget_title',$instance['title']);
				if(!empty($title)){echo $before_title . $title . $after_title;}
	
				echo createLanguageSelector($instance['type']);
	 
				echo $after_widget;
			}
		}
		add_action('widgets_init',create_function('','return register_widget("OurEgoLanguageWidget");'));
	


// LANGUAGE RESOURCE FUNCTIONS

		function getLanguages(){
			if(get_option('language_languages') != ''){
				return explode(',',get_option('language_languages'));
			}else{
				return false;
			}
		}

		function getAvailableLanguages(){
			if(get_option('language_available') != ''){
				return explode(',',get_option('language_available'));
			}else{
				return false;
			}
		}
	
		function getLocale($lang = '',$country = false){

		//	$local['af'] = 'af_ZA';																														//Afrikaans (South Africa)
		//	$local['ar'] = 'ar_AE,ar_BH,ar_DZ,ar_EG,ar_IQ,ar_JO,ar_KW,ar_LB,ar_LY,ar_MA,ar_OM,ar_QA,ar_SA,ar_SY,ar_TN,ar_YE';							//Arabic (U.A.E., Bahrain, Algeria, Egypt, Iraq, Jordan, Kuwait, Lebanon, Libya, Morocco, Oman, Qatar, Saudi Arabia, Syria, Tunisia, Yemen)
		//	$local['az'] = 'az_AZ';																														//Azeri (Latin, Cyrillic) (Azerbaijan)
			$local['be'] = 'be_BY';																														//Belarusian (Belarus)
			$local['bg'] = 'bg_BG';																														//Bulgarian (Bulgaria)
			$local['bs'] = 'bs_BA';																														//Bosnian (Bosnia and Herzegovina)
			$local['ca'] = 'ca_ES';																														//Catalan (Spain)
			$local['cs'] = 'cs_CZ';																														//Czech (Czech Republic)
			$local['cy'] = 'cy_GB';																														//Welsh (United Kingdom)
			$local['da'] = 'da_DK';																														//Danish (Denmark)
			$local['de'] = 'de_DE,de_AT,de_CH,de_LI,de_LU';																								//German (Germany,Austria,Switzerland,Liechtenstein,Luxembourg)
		//	$local['dv'] = 'dv_MV';																														//Divehi (Maldives)
			$local['el'] = 'el_GR';																														//Greek (Greece)
			$local['en'] = 'en_GB,en_US,en_AU,en_CA,en_NZ,en_IE,en_JM,en_PH,en_TT,en_ZA,en_ZW,en_CB,en_BZ';												//English (United Kingdom,United States,Australia,Canada,New Zealand,Ireland, Jamaica, Republic of the Philippines, Trinidad and Tobago, South Africa, Zimbabwe, Caribbean, Belize)
		//	$local['eo'] = 'eo';																														//Esperanto
			$local['es'] = 'es_ES,es_AR,es_BO,es_CL,es_CO,es_CR,es_DO,es_EC,es_ES,es_GT,es_HN,es_MX,es_NI,es_PA,es_PE,es_PR,es_PY,es_SV,es_UY,es_VE';	//Spanish (Spain, Argentina, Bolivia, Chile, Colombia, Costa Rica, Dominican Republic, Ecuador, Castilian, Guatemala, Honduras, Mexico, Nicaragua, Panama, Peru, Puerto Rico, Paraguay, El Salvador, Uruguay, Venezuela)
			$local['et'] = 'et_EE';																														//Estonian (Estonia)
			$local['eu'] = 'eu_ES';																														//Basque (Spain)
			$local['fa'] = 'fa_IR';																														//Farsi (Iran)
			$local['fi'] = 'fi_FI';																														//Finnish (Finland)
			$local['fo'] = 'fo_FO';																														//Faroese (Faroe Islands)
			$local['fr'] = 'fr_FR,fr_BE,fr_CA,fr_CH,fr_LU,fr_MC';																						//French (France, Belgium, Canada, Switzerland, Luxembourg, Principality of Monaco)
			//$local['fr'] = 'fr_FR,fr_BE,fr_CA,fr_CH,fr_LU,fr_MC';																						//French (France, Belgium, Canada, Switzerland, Luxembourg, Principality of Monaco)
			$local['fc'] = 'fc_CA';																														// * French Canada - made up code
		//	$local['gl'] = 'gl_ES';																														//Galician (Spain)
		//	$local['gu'] = 'gu_IN';																														//Gujarati (India)
		//	$local['he'] = 'he_IL';																														//Hebrew (Israel)
		//	$local['hi'] = 'hi_IN';																														//Hindi (India)
			$local['hr'] = 'hr_BA,hr_HR';																												//Croatian (Bosnia and Herzegovina, Croatia)
			$local['hu'] = 'hu_HU';																														//Hungarian (Hungary)
		//	$local['hy'] = 'hy_AM';																														//Armenian (Armenia)
			$local['id'] = 'id_ID';																														//Indonesian (Indonesia)
			$local['is'] = 'is_IS';																														//Icelandic (Iceland)
			$local['it'] = 'it_IT,it_CH';																												//Italian (Italy, Switzerland)
			$local['ja'] = 'ja_JP';																														//Japanese (Japan)
		//	$local['ka'] = 'ka_GE';																														//Georgian (Georgia)
		//	$local['kk'] = 'kk_KZ';																														//Kazakh (Kazakhstan)
		//	$local['kn'] = 'kn_IN';																														//Kannada (India)
			$local['ko'] = 'ko_KR';																														//Korean (Korea)
		//	$local['kok'] = 'kok_IN';																													//Konkani (India)
		//	$local['ky'] = 'ky_KG';																														//Kyrgyz (Kyrgyzstan)
			$local['lt'] = 'lt_LT';																														//Lithuanian (Lithuania)
			$local['lv'] = 'lv_LV';																														//Latvian (Latvia)
		//	$local['mi'] = 'mi_NZ';																														//Maori (New Zealand)
			$local['mk'] = 'mk_MK';																														//FYRO Macedonian (Former Yugoslav Republic of Macedonia)
			$local['mn'] = 'mn_MN';																														//Mongolian (Mongolia)
			$local['mr'] = 'mr_IN';																														//Marathi (India)
			$local['ms'] = 'ms_MY,ms_BN';																												//Malay (Malaysia, Brunei Darussalam)
			$local['mt'] = 'mt_MT';																														//Maltese (Malta)
			$local['nb'] = 'nb_NO';																														//Norwegian (Bokmål) (Norway)
			$local['nl'] = 'nl_NL,nl_BE';																												//Dutch (Netherlands, Belgium)
			$local['nn'] = 'nn_NO';																														//Norwegian (Nynorsk) (Norway)
		//	$local['ns'] = 'ns_ZA';																														//Northern Sotho (South Africa)
		//	$local['pa'] = 'pa_IN';																														//Punjabi (India)
			$local['pl'] = 'pl_PL';																														//Polish (Poland)
		//	$local['ps'] = 'ps_AR';																														//Pashto (Afghanistan)
			$local['pt'] = 'pt_PT';//,pt_BR';																												//Portuguese (Portugal, Brazil)
			$local['pb'] = 'pb_BR';																														// * Portuguese Brazil - Made up code
		//	$local['qu'] = 'qu_BO,qu_EC,qu_PE';																											//Quechua (Bolivia, Ecuador, Peru)
			$local['ru'] = 'ru_RU,ro_RO';																												//Russian (Russia, Romania)
		//	$local['sa'] = 'sa_IN';																														//Sanskrit (India)
		//	$local['se'] = 'se_SE,se_NO,se_FI';																											//Sami (Sweden - Northern, Lule, Southern; Norway - Northern, Lule, Southern; Finland - Northern, Skolt, Inari)
			$local['sk'] = 'sk_SK';																														//Slovak (Slovakia)
			$local['sl'] = 'sl_SI';																														//Slovenian (Slovenia)
			$local['sa'] = 'sq_AL';																														//Albanian (Albania)
			$local['sr'] = 'sr_BA,sr_SP';																												//Serbian (Latin, Cyrillic) (Bosnia and Herzegovina, Serbia and Montenegro)
			$local['sv'] = 'sv_SE,sv_FI';																												//Swedish (Sweden, Finland)
		//	$local['sw'] = 'sw_KE';																														//Swahili (Kenya)
		//	$local['syr']= 'syr_SY';																													//Syriac (Syria)
		//	$local['ta'] = 'ta_IN';																														//Tamil (India)
		//	$local['te'] = 'te_IN';																														//Telugu (India)
			$local['th'] = 'th_TH';																														//Thai (Thailand)
		//	$local['tl'] = 'tl_PH';																														//Tagalog (Philippines)
		//	$local['tn'] = 'tn_ZA';																														//Tswana (South Africa)
			$local['tr'] = 'tr_TR';																														//Turkish (Turkey)
			$local['tt'] = 'tt_RU';																														//Tatar (Russia)
		//	$local['ts'] = 'ts';																														//Tsonga
			$local['uk'] = 'uk_UA';																														//Ukrainian (Ukraine)
		//	$local['ur'] = 'ur_PK';																														//Urdu (Islamic Republic of Pakistan)
		//	$local['uz'] = 'uz_UZ';																														//Uzbek (Latin, Cyrillic) (Uzbekistan)
			$local['vi'] = 'vi_VN';																														//Vietnamese (Viet Nam)
		//	$local['xh'] = 'xh_ZA';																														//Xhosa (South Africa)
			$local['zh'] = 'zh_CN,zh_HK,zh_MO,zh_SG,zh_TW';																								//Chinese (S, Hong Kong, Macau, Singapore, T)
		//	$local['zu'] = 'zu_ZA';																														//Zulu (South Africa)
	
			if($lang != '' && $country){
				return substr($local[strtolower($lang)],3,2);
			}elseif($lang != ''){
				return substr($local[strtolower($lang)],0,5);
			}else{
				return $local;
			}
		}

		function getLanguageName($lang = ''){
		
			$language['aa'] = 'Afar';
			$language['ab'] = 'Abkhazian';
			$language['ae'] = 'Avestan';
			$language['af'] = 'Afrikaans';
			$language['ak'] = 'Akan';
			$language['am'] = 'Amharic';
			$language['an'] = 'Aragonese';
			$language['ar'] = 'Arabic';
			$language['as'] = 'Assamese';
			$language['av'] = 'Avaric';
			$language['ay'] = 'Aymara';
			$language['az'] = 'Azerbaijani';
			$language['ba'] = 'Bashkir';
			$language['be'] = 'Belarusian';
			$language['bg'] = 'Bulgarian';
			$language['bh'] = 'Bihari';
			$language['bi'] = 'Bislama';
			$language['bm'] = 'Bambara';
			$language['bn'] = 'Bengali; Bangla';
			$language['bo'] = 'Tibetan';
			$language['br'] = 'Breton';
			$language['bs'] = 'Bosnian';
			$language['ca'] = 'Catalan';
			$language['ce'] = 'Chechen';
			$language['ch'] = 'Chamorro';
			$language['co'] = 'Corsican';
			$language['cr'] = 'Cree';
			$language['cs'] = 'Czech';
			$language['cu'] = 'Church Slavic';
			$language['cv'] = 'Chuvash';
			$language['cy'] = 'Welsh';
			$language['da'] = 'Danish';
			$language['de'] = 'German';
			$language['dv'] = 'Divehi; Maldivian';
			$language['dz'] = 'Dzongkha; Bhutani';
			$language['ee'] = 'Éwé';
			$language['el'] = 'Greek';
			$language['en'] = 'English';
			$language['eo'] = 'Esperanto';
			$language['es'] = 'Spanish';
			$language['et'] = 'Estonian';
			$language['eu'] = 'Basque';
			$language['fa'] = 'Persian';
			$language['ff'] = 'Fulah';
			$language['fi'] = 'Finnish';
			$language['fj'] = 'Fijian; Fiji';
			$language['fo'] = 'Faroese';
			$language['fr'] = 'French';
			$language['fc'] = 'French Canada'; // Made up code
			$language['fy'] = 'Western Frisian';
			$language['ga'] = 'Irish';
			$language['gd'] = 'Scottish Gaelic';
			$language['gl'] = 'Galician';
			$language['gn'] = 'Guarani';
			$language['gu'] = 'Gujarati';
			$language['gv'] = 'Manx';
			$language['ha'] = 'Hausa';
			$language['he'] = 'Hebrew'; // (formerly iw)
			$language['hi'] = 'Hindi';
			$language['ho'] = 'Hiri Motu';
			$language['hr'] = 'Croatian';
			$language['ht'] = 'Haitian; Haitian Creole';
			$language['hu'] = 'Hungarian';
			$language['hy'] = 'Armenian';
			$language['hz'] = 'Herero';
			$language['ia'] = 'Interlingua';
			$language['id'] = 'Indonesian'; // (formerly in)
			$language['ie'] = 'Interlingue; Occidental';
			$language['ig'] = 'Igbo';
			$language['ii'] = 'Sichuan Yi; Nuosu';
			$language['ik'] = 'Inupiak; Inupiaq';
			$language['io'] = 'Ido';
			$language['is'] = 'Icelandic';
			$language['it'] = 'Italian';
			$language['iu'] = 'Inuktitut';
			$language['ja'] = 'Japanese';
			$language['jv'] = 'Javanese';
			$language['ka'] = 'Georgian';
			$language['kg'] = 'Kongo';
			$language['ki'] = 'Kikuyu; Gikuyu';
			$language['kj'] = 'Kuanyama; Kwanyama';
			$language['kk'] = 'Kazakh';
			$language['kl'] = 'Kalaallisut; Greenlandic';
			$language['km'] = 'Central Khmer; Cambodian';
			$language['kn'] = 'Kannada';
			$language['ko'] = 'Korean';
			$language['kr'] = 'Kanuri';
			$language['ks'] = 'Kashmiri';
			$language['ku'] = 'Kurdish';
			$language['kv'] = 'Komi';
			$language['kw'] = 'Cornish';
			$language['ky'] = 'Kirghiz';
			$language['la'] = 'Latin';
			$language['lb'] = 'Letzeburgesch; Luxembourgish';
			$language['lg'] = 'Ganda';
			$language['li'] = 'Limburgish; Limburger; Limburgan';
			$language['ln'] = 'Lingala';
			$language['lo'] = 'Lao; Laotian';
			$language['lt'] = 'Lithuanian';
			$language['lu'] = 'Luba-Katanga';
			$language['lv'] = 'Latvian; Lettish';
			$language['mg'] = 'Malagasy';
			$language['mh'] = 'Marshallese';
			$language['mi'] = 'Maori';
			$language['mk'] = 'Macedonian';
			$language['ml'] = 'Malayalam';
			$language['mn'] = 'Mongolian';
			$language['mo'] = 'Moldavian';
			$language['mr'] = 'Marathi';
			$language['ms'] = 'Malay';
			$language['mt'] = 'Maltese';
			$language['my'] = 'Burmese';
			$language['na'] = 'Nauru';
			$language['nb'] = 'Norwegian Bokmål';
			$language['nd'] = 'Ndebele North';
			$language['ne'] = 'Nepali';
			$language['ng'] = 'Ndonga';
			$language['nl'] = 'Dutch';
			$language['nn'] = 'Norwegian Nynorsk';
			$language['no'] = 'Norwegian';
			$language['nr'] = 'Ndebele South';
			$language['nv'] = 'Navajo; Navaho';
			$language['ny'] = 'Chichewa; Nyanja';
			$language['oc'] = 'Occitan; Provençal';
			$language['oj'] = 'Ojibwa';
			$language['om'] = '(Afan) Oromo';
			$language['or'] = 'Oriya';
			$language['os'] = 'Ossetian; Ossetic';
			$language['pa'] = 'Panjabi; Punjabi';
			$language['pi'] = 'Pali';
			$language['pl'] = 'Polish';
			$language['ps'] = 'Pashto; Pushto';
			$language['pt'] = 'Portuguese';
			$language['pb'] = 'Portuguese Brazil';
			$language['qu'] = 'Quechua';
			$language['rm'] = 'Romansh';
			$language['rn'] = 'Rundi; Kirundi';
			$language['ro'] = 'Romanian';
			$language['ru'] = 'Russian';
			$language['rw'] = 'Kinyarwanda';
			$language['sa'] = 'Sanskrit';
			$language['sc'] = 'Sardinian';
			$language['sd'] = 'Sindhi';
			$language['se'] = 'Northern Sami';
			$language['sg'] = 'Sango; Sangro';
			$language['si'] = 'Sinhala; Sinhalese';
			$language['sk'] = 'Slovak';
			$language['sl'] = 'Slovenian';
			$language['sm'] = 'Samoan';
			$language['sn'] = 'Shona';
			$language['so'] = 'Somali';
			$language['sq'] = 'Albanian';
			$language['sr'] = 'Serbian';
			$language['ss'] = 'Swati; Siswati';
			$language['st'] = 'Sesotho; Sotho =  Southern';
			$language['su'] = 'Sundanese';
			$language['sv'] = 'Svenska';
			$language['sw'] = 'Swahili';
			$language['ta'] = 'Tamil';
			$language['te'] = 'Telugu';
			$language['tg'] = 'Tajik';
			$language['th'] = 'Thai';
			$language['ti'] = 'Tigrinya';
			$language['tk'] = 'Turkmen';
			$language['tl'] = 'Tagalog';
			$language['tn'] = 'Tswana; Setswana';
			$language['to'] = 'Tonga';
			$language['tr'] = 'Turkish';
			$language['ts'] = 'Tsonga';
			$language['tt'] = 'Tatar';
			$language['tw'] = 'Twi';
			$language['ty'] = 'Tahitian';
			$language['ug'] = 'Uighur';
			$language['uk'] = 'Ukrainian';
			$language['ur'] = 'Urdu';
			$language['uz'] = 'Uzbek';
			$language['ve'] = 'Venda';
			$language['vi'] = 'Vietnamese';
			$language['vo'] = 'Volapük; Volapuk';
			$language['wa'] = 'Walloon';
			$language['wo'] = 'Wolof';
			$language['xh'] = 'Xhosa';
			$language['yi'] = 'Yiddish (formerly ji)';
			$language['yo'] = 'Yoruba';
			$language['za'] = 'Zhuang';
			$language['zh'] = 'Chinese';
			$language['zu'] = 'Zulu';
		
			$language['ace'] = 'Achinese'; 
			$language['awa'] = 'Awadhi'; 
			$language['bal'] = 'Baluchi'; 
			$language['ban'] = 'Balinese'; 
			$language['bej'] = 'Beja; Bedawiyet'; 
			$language['bem'] = 'Bemba'; 
			$language['bho'] = 'Bhojpuri'; 
			$language['bik'] = 'Bikol'; 
			$language['bin'] = 'Bini; Edo'; 
			$language['bug'] = 'Buginese'; 
			$language['ceb'] = 'Cebuano'; 
			$language['din'] = 'Dinka'; 
			$language['doi'] = 'Dogri'; 
			$language['fil'] = 'Filipino; Pilipino'; 
			$language['fon'] = 'Fon'; 
			$language['gon'] = 'Gondi'; 
			$language['gsw'] = 'Swiss German; Alemannic; Alsatian'; 
			$language['hil'] = 'Hiligaynon'; 
			$language['hmn'] = 'Hmong'; 
			$language['ilo'] = 'Iloko'; 
			$language['kab'] = 'Kabyle'; 
			$language['kam'] = 'Kamba'; 
			$language['kbd'] = 'Kabardian'; 
			$language['kmb'] = 'Kimbundu'; 
			$language['kok'] = 'Konkani'; 
			$language['kru'] = 'Kurukh'; 
			$language['lua'] = 'Luba-Lulua'; 
			$language['luo'] = 'Luo (Kenya and Tanzania)'; 
			$language['mad'] = 'Madurese'; 
			$language['mag'] = 'Magahi'; 
			$language['mai'] = 'Maithili'; 
			$language['mak'] = 'Makasar'; 
			$language['man'] = 'Mandingo'; 
			$language['men'] = 'Mende'; 
			$language['min'] = 'Minangkabau'; 
			$language['mni'] = 'Manipuri'; 
			$language['mos'] = 'Mossi'; 
			$language['mwr'] = 'Marwari'; 
			$language['nap'] = 'Neapolitan'; 
			$language['nso'] = 'Pedi; Sepedi; Northern Sotho'; 
			$language['nym'] = 'Nyamwezi'; 
			$language['nyn'] = 'Nyankole'; 
			$language['pag'] = 'Pangasinan'; 
			$language['pam'] = 'Pampanga; Kapampangan'; 
			$language['raj'] = 'Rajasthani'; 
			$language['sas'] = 'Sasak'; 
			$language['sat'] = 'Santali'; 
			$language['scn'] = 'Sicilian'; 
			$language['shn'] = 'Shan'; 
			$language['sid'] = 'Sidamo'; 
			$language['srr'] = 'Serer'; 
			$language['suk'] = 'Sukuma'; 
			$language['sus'] = 'Susu'; 
			$language['tem'] = 'Timne'; 
			$language['tiv'] = 'Tiv'; 
			$language['tum'] = 'Tumbuka'; 
			$language['umb'] = 'Umbundu'; 
			$language['wal'] = 'Walamo'; 
			$language['war'] = 'Waray'; 
			$language['yao'] = 'Yao';
		
			if($lang != ''){
				return $language[strtolower($lang)];
			}else{
				return $language;
			}
		}

		function getLanguageLocalName($lang = ''){
	
			$language['it'] = 'Italiano';
			$language['da'] = 'Dansk';
			$language['de'] = 'Deutsch';
			$language['en'] = 'English';
			$language['es'] = 'Español';
			$language['fr'] = 'Français';
			$language['fc'] = 'Français (Canada)'; // Made up code
			$language['nl'] = 'Nederlands';
			$language['nn'] = 'Norsk';
			$language['pb'] = 'Português (Brazil)'; // Made up code
			$language['sv'] = 'Svenska';
			$language['zh'] = '中文';
			
			if($lang != ''){
				return $language[strtolower($lang)];
			}else{
				return $language;
			}
		}

		function getCountryName($code = ''){
	
			$country['AD'] = 'Andorra';
			$country['AE'] = 'United Arab Emirates';
			$country['AF'] = 'Afghanistan';
			$country['AG'] = 'Antigua and Barbuda';
			$country['AI'] = 'Anguilla';
			$country['AL'] = 'Albania';
			$country['AM'] = 'Armenia';
			$country['AN'] = 'Netherlands Antilles';
			$country['AO'] = 'Angola';
			$country['AQ'] = 'Antarctica';
			$country['AR'] = 'Argentina';
			$country['AS'] = 'Samoa (American)';
			$country['AT'] = 'Austria';
			$country['AU'] = 'Australia';
			$country['AW'] = 'Aruba';
			$country['AX'] = 'Aaland Islands';
			$country['AZ'] = 'Azerbaijan';
			$country['BA'] = 'Bosnia and Herzegovina';
			$country['BB'] = 'Barbados';
			$country['BD'] = 'Bangladesh';
			$country['BE'] = 'Belgium';
			$country['BF'] = 'Burkina Faso';
			$country['BG'] = 'Bulgaria';
			$country['BH'] = 'Bahrain';
			$country['BI'] = 'Burundi';
			$country['BJ'] = 'Benin';
			$country['BM'] = 'Bermuda';
			$country['BN'] = 'Brunei';
			$country['BO'] = 'Bolivia';
			$country['BR'] = 'Brazil';
			$country['BS'] = 'Bahamas';
			$country['BT'] = 'Bhutan';
			$country['BV'] = 'Bouvet Island';
			$country['BW'] = 'Botswana';
			$country['BY'] = 'Belarus';
			$country['BZ'] = 'Belize';
			$country['CA'] = 'Canada';
			$country['CC'] = 'Cocos (Keeling) Islands';
			$country['CD'] = 'Congo (Democratic Republic)';
			$country['CF'] = 'Central African Republic';
			$country['CG'] = 'Congo (Rep.)';
			$country['CH'] = 'Switzerland';
			$country['CI'] = 'Côte d´Ivoire';
			$country['CK'] = 'Cook Islands';
			$country['CL'] = 'Chile';
			$country['CM'] = 'Cameroon';
			$country['CN'] = 'China';
			$country['CO'] = 'Colombia';
			$country['CR'] = 'Costa Rica';
			$country['CU'] = 'Cuba';
			$country['CV'] = 'Cape Verde';
			$country['CX'] = 'Christmas Island';
			$country['CY'] = 'Cyprus';
			$country['CZ'] = 'Czech Republic';
			$country['DE'] = 'Germany';
			$country['DJ'] = 'Djibouti';
			$country['DK'] = 'Denmark';
			$country['DM'] = 'Dominica';
			$country['DO'] = 'Dominican Republic';
			$country['DZ'] = 'Algeria';
			$country['EC'] = 'Ecuador';
			$country['EE'] = 'Estonia';
			$country['EG'] = 'Egypt';
			$country['EH'] = 'Western Sahara';
			$country['ER'] = 'Eritrea';
			$country['ES'] = 'Spain';
			$country['ET'] = 'Ethiopia';
			$country['FI'] = 'Finland';
			$country['FJ'] = 'Fiji';
			$country['FK'] = 'Falkland Islands';
			$country['FM'] = 'Micronesia';
			$country['FO'] = 'Faeroe Islands';
			$country['FR'] = 'France';
			$country['GA'] = 'Gabon';
			$country['GB'] = 'Britain (United Kingdom)';
			$country['GD'] = 'Grenada';
			$country['GE'] = 'Georgia';
			$country['GF'] = 'French Guiana';
			$country['GG'] = 'Guernsey';
			$country['GH'] = 'Ghana';
			$country['GI'] = 'Gibraltar';
			$country['GL'] = 'Greenland';
			$country['GM'] = 'Gambia';
			$country['GN'] = 'Guinea';
			$country['GP'] = 'Guadeloupe';
			$country['GQ'] = 'Equatorial Guinea';
			$country['GR'] = 'Greece';
			$country['GS'] = 'South Georgia and the South Sandwich Islands';
			$country['GT'] = 'Guatemala';
			$country['GU'] = 'Guam';
			$country['GW'] = 'Guinea-Bissau';
			$country['GY'] = 'Guyana';
			$country['HK'] = 'Hong Kong';
			$country['HM'] = 'Heard Island and McDonald Islands';
			$country['HN'] = 'Honduras';
			$country['HR'] = 'Croatia';
			$country['HT'] = 'Haiti';
			$country['HU'] = 'Hungary';
			$country['ID'] = 'Indonesia';
			$country['IE'] = 'Ireland';
			$country['IL'] = 'Israel';
			$country['IM'] = 'Isle of Man';
			$country['IN'] = 'India';
			$country['IO'] = 'British Indian Ocean Territory';
			$country['IQ'] = 'Iraq';
			$country['IR'] = 'Iran';
			$country['IS'] = 'Iceland';
			$country['IT'] = 'Italy';
			$country['JE'] = 'Jersey';
			$country['JM'] = 'Jamaica';
			$country['JO'] = 'Jordan';
			$country['JP'] = 'Japan';
			$country['KE'] = 'Kenya';
			$country['KG'] = 'Kyrgyzstan';
			$country['KH'] = 'Cambodia';
			$country['KI'] = 'Kiribati';
			$country['KM'] = 'Comoros';
			$country['KN'] = 'St Kitts and Nevis';
			$country['KP'] = 'Korea (North)';
			$country['KR'] = 'Korea (South)';
			$country['KW'] = 'Kuwait';
			$country['KY'] = 'Cayman Islands';
			$country['KZ'] = 'Kazakhstan';
			$country['LA'] = 'Laos';
			$country['LB'] = 'Lebanon';
			$country['LC'] = 'St Lucia';
			$country['LI'] = 'Liechtenstein';
			$country['LK'] = 'Sri Lanka';
			$country['LR'] = 'Liberia';
			$country['LS'] = 'Lesotho';
			$country['LT'] = 'Lithuania';
			$country['LU'] = 'Luxembourg';
			$country['LV'] = 'Latvia';
			$country['LY'] = 'Libya';
			$country['MA'] = 'Morocco';
			$country['MC'] = 'Monaco';
			$country['MD'] = 'Moldova';
			$country['ME'] = 'Montenegro';
			$country['MG'] = 'Madagascar';
			$country['MH'] = 'Marshall Islands';
			$country['MK'] = 'Macedonia';
			$country['ML'] = 'Mali';
			$country['MM'] = 'Myanmar (Burma)';
			$country['MN'] = 'Mongolia';
			$country['MO'] = 'Macao';
			$country['MP'] = 'Northern Mariana Islands';
			$country['MQ'] = 'Martinique';
			$country['MR'] = 'Mauritania';
			$country['MS'] = 'Montserrat';
			$country['MT'] = 'Malta';
			$country['MU'] = 'Mauritius';
			$country['MV'] = 'Maldives';
			$country['MW'] = 'Malawi';
			$country['MX'] = 'Mexico';
			$country['MY'] = 'Malaysia';
			$country['MZ'] = 'Mozambique';
			$country['NA'] = 'Namibia';
			$country['NC'] = 'New Caledonia';
			$country['NE'] = 'Niger';
			$country['NF'] = 'Norfolk Island';
			$country['NG'] = 'Nigeria';
			$country['NI'] = 'Nicaragua';
			$country['NL'] = 'Netherlands';
			$country['NO'] = 'Norway';
			$country['NP'] = 'Nepal';
			$country['NR'] = 'Nauru';
			$country['NU'] = 'Niue';
			$country['NZ'] = 'New Zealand';
			$country['OM'] = 'Oman';
			$country['PA'] = 'Panama';
			$country['PE'] = 'Peru';
			$country['PF'] = 'French Polynesia';
			$country['PG'] = 'Papua New Guinea';
			$country['PH'] = 'Philippines';
			$country['PK'] = 'Pakistan';
			$country['PL'] = 'Poland';
			$country['PM'] = 'St Pierre and Miquelon';
			$country['PN'] = 'Pitcairn';
			$country['PR'] = 'Puerto Rico';
			$country['PS'] = 'Palestine';
			$country['PT'] = 'Portugal';
			$country['PW'] = 'Palau';
			$country['PY'] = 'Paraguay';
			$country['QA'] = 'Qatar';
			$country['RE'] = 'Reunion';
			$country['RO'] = 'Romania';
			$country['RS'] = 'Serbia';
			$country['RU'] = 'Russia';
			$country['RW'] = 'Rwanda';
			$country['SA'] = 'Saudi Arabia';
			$country['SB'] = 'Solomon Islands';
			$country['SC'] = 'Seychelles';
			$country['SD'] = 'Sudan';
			$country['SE'] = 'Sweden';
			$country['SG'] = 'Singapore';
			$country['SH'] = 'St Helena';
			$country['SI'] = 'Slovenia';
			$country['SJ'] = 'Svalbard and Jan Mayen';
			$country['SK'] = 'Slovakia';
			$country['SL'] = 'Sierra Leone';
			$country['SM'] = 'San Marino';
			$country['SN'] = 'Senegal';
			$country['SO'] = 'Somalia';
			$country['SR'] = 'Suriname';
			$country['ST'] = 'Sao Tome and Principe';
			$country['SV'] = 'El Salvador';
			$country['SY'] = 'Syria';
			$country['SZ'] = 'Swaziland';
			$country['TC'] = 'Turks and Caicos Islands';
			$country['TD'] = 'Chad';
			$country['TF'] = 'French Southern and Antarctic Lands';
			$country['TG'] = 'Togo';
			$country['TH'] = 'Thailand';
			$country['TJ'] = 'Tajikistan';
			$country['TK'] = 'Tokelau';
			$country['TL'] = 'Timor-Leste';
			$country['TM'] = 'Turkmenistan';
			$country['TN'] = 'Tunisia';
			$country['TO'] = 'Tonga';
			$country['TR'] = 'Turkey';
			$country['TT'] = 'Trinidad and Tobago';
			$country['TV'] = 'Tuvalu';
			$country['TW'] = 'Taiwan';
			$country['TZ'] = 'Tanzania';
			$country['UA'] = 'Ukraine';
			$country['UG'] = 'Uganda';
			$country['UM'] = 'US minor outlying islands';
			$country['US'] = 'United States';
			$country['UY'] = 'Uruguay';
			$country['UZ'] = 'Uzbekistan';
			$country['VA'] = 'Vatican City';
			$country['VC'] = 'St Vincent and the Grenadines';
			$country['VE'] = 'Venezuela';
			$country['VG'] = 'Virgin Islands (UK)';
			$country['VI'] = 'Virgin Islands (US)';
			$country['VN'] = 'Vietnam';
			$country['VU'] = 'Vanuatu';
			$country['WF'] = 'Wallis and Futuna';
			$country['WS'] = 'Samoa (Western)';
			$country['YE'] = 'Yemen';
			$country['YT'] = 'Mayotte';
			$country['ZA'] = 'South Africa';
			$country['ZM'] = 'Zambia';
			$country['ZW'] = 'Zimbabwe';
		
			if($code != ''){
				return $country[strtoupper($code)];
			}else{
				return $country;
			}
		}
	

/// AUTOMATIC UPDATES init and class

		global $ourego_languages_version;
		function ourego_languages_activate_au(){
			global $ourego_languages_version;
			new ourego_languages_auto_update($ourego_languages_version);
		}
		add_action('init','ourego_languages_activate_au');
		class ourego_languages_auto_update{
			public $current_version;
			function __construct($current_version){
				$this->current_version = $current_version;
				$this->update_path = 'http://ourego.com/wp-content/plugins/ourego-languages-update.php';
				$this->plugin_slug = plugin_basename(__FILE__);
				list($t1,$t2) = explode('/',$this->plugin_slug);
				$this->slug = str_replace('.php','',$t2);
				add_filter('pre_set_site_transient_update_plugins',array(&$this,'check_update'));
				add_filter('plugins_api',array(&$this,'check_info'),10,3);
			}
			public function check_update($transient){
				if(empty($transient->checked)){
					return $transient;
				}
				$remote_version = $this->getRemote_version();
				if(version_compare($this->current_version,$remote_version,'<')){
					$obj = new stdClass();
					$obj->slug = $this->slug;
					$obj->new_version = $remote_version;
					$obj->url = $this->update_path;
					$obj->package = $this->update_path;
					$transient->response[$this->plugin_slug] = $obj;
				}
				return $transient;
			}
			public function check_info($false,$action,$arg){
				if($arg->slug === $this->slug){
					$information = $this->getRemote_information();  
					return $information;  
				}  
				return false;  
			}  
			public function getRemote_version(){  
				$request = wp_remote_post($this->update_path,array('body' => array('action' => 'version')));
				if(!is_wp_error($request) || wp_remote_retrieve_response_code($request) === 200){
					return $request['body'];
				}
				return false;
			}
			public function getRemote_information(){
				$request = wp_remote_post($this->update_path,array('body' => array('action' => 'info')));
				if(!is_wp_error($request) || wp_remote_retrieve_response_code($request) === 200){
					return unserialize($request['body']);
				}
				return false;
			}
		}

?>